/*
 *    Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

/**
 * ATNAQuestionnaireType.java
 * <p/>
 * File generated from the ATNAQuestionnaire::ATNAQuestionnaireType uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.atna.questionnaire.model;

import net.ihe.gazelle.atna.questionnaire.preferences.UserAttributes;
import net.ihe.gazelle.hql.FilterLabel;
import org.hibernate.annotations.Type;
import org.jboss.seam.security.Identity;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

// End of user code

/**
 * Description of the class ATNAQuestionnaireType.
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ATNAQuestionnaire_._type", propOrder = {"inboundNetworkCommunication",
        "outboundNetworkCommunication", "auditedEvent", "localUserAuthenticationProcess", "tLSTest",
        "nonNetworkMeanForAccessingPHI", "company", "lastModified", "lastModifier", "lastModifierCasKey", "oid",
        "reviewer", "reviewerCasKey", "status", "system", "systemType", "testingSession", "username", "usernameCasKey"})
@XmlRootElement(name = "ATNAQuestionnaire")
@Entity
@Table(name = "atna_questionnaire", schema = "public")
@SequenceGenerator(name = "atna_questionnaire_sequence", sequenceName = "atna_questionnaire_id_seq", allocationSize = 1)
public class ATNAQuestionnaireType implements java.io.Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 1L;
    private static final int KEY_LENGTH = 8;

    @Id
    @NotNull
    @GeneratedValue(generator = "atna_questionnaire_sequence", strategy = GenerationType.SEQUENCE)
    @Column(name = "id", unique = true, nullable = false)
    @XmlTransient
    private Integer id;

    /**
     * One entry per interface (actor/transaction)
     */
    @XmlElement(name = "NetworkCommunication")
    @OneToMany(mappedBy = "atnaQuestionnaire", orphanRemoval = true, cascade = {CascadeType.ALL})
    private List<NetworkCommunication> networkCommunications;

    /**
     * list the events which must be audited and give the user the possibility to attach the link to the EVSClient report of audit trail message
     * validation.
     */
    @XmlElement(name = "AuditedEvent")
    @OneToMany(mappedBy = "atnaQuestionnaire", orphanRemoval = true, cascade = {CascadeType.ALL})
    private List<AuditedEvent> auditedEvent;
    /**
     * In the former questionnaire, user was asked to describe the authentication process of local users.
     */
    @XmlElement(name = "LocalUserAuthenticationProcess")
    @Lob
    @Type(type = "text")
    @Column(name = "local_user_authentication_process")
    private String localUserAuthenticationProcess;
    /**
     * One entry per inbound/outbound network communication type : Will help the user to know which TLS tests to perform and the monitor to check
     * that all tests were performed and OK.
     */
    @XmlElement(name = "TLSTest")
    @OneToMany(mappedBy = "atnaQuestionnaire", orphanRemoval = true, cascade = {CascadeType.ALL})
    private List<TLSTest> tLSTest;
    /**
     * comes from 3b in former questionnaire, needs to determine what we expect here in the new questionnaire.
     */
    @XmlElement(name = "NonNetworkMeanForAcessingPHI")
    @Lob
    @Type(type = "text")
    @Column(name = "non_network_mean_for_accessing_phi")
    private String nonNetworkMeanForAccessingPHI;
    /**
     * which company owns the SUT.
     */
    @XmlAttribute(name = "company", required = true)
    @Column(name = "company")
    private String company;

    @XmlAttribute(name = "lastModified")
    @XmlSchemaType(name = "date")
    @Transient
    private javax.xml.datatype.XMLGregorianCalendar lastModified;

    @XmlTransient
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "last_modified_date", columnDefinition = "timestamp with time zone")
    private Date lastModifiedDate;

    @XmlAttribute(name = "lastModifier")
    @Column(name = "last_modifier")
    private String lastModifier;

    @XmlAttribute(name = "lastModifierCasKey")
    @Column(name = "last_modifier_cas_key", length = KEY_LENGTH)
    private String lastModifierCasKey;

    /**
     * unique identifier of the questionnaire.
     */
    @XmlAttribute(name = "oid", required = true)
    @Column(name = "oid")
    private String oid;

    /**
     * monitor who reviewed the questionnaire.
     */
    @XmlAttribute(name = "reviewer")
    @Column(name = "reviewer")
    private String reviewer;

    @XmlAttribute(name = "reviewerCasKey")
    @Column(name = "reviewer_cas_key", length = KEY_LENGTH)
    private String reviewerCasKey;

    /**
     * status of the questionnaire.
     */
    @XmlAttribute(name = "status", required = true)
    @Column(name = "status")
    private Status status;

    /**
     * system keyword in TM.
     */
    @XmlAttribute(name = "system", required = true)
    @Column(name = "system")
    private String system;

    /**
     * is the SUT secure application or secure node.
     */
    @XmlAttribute(name = "systemType", required = true)
    @Column(name = "system_type")
    private SystemType systemType;

    @XmlElement(name = "TestingSession", required = true)
    @JoinColumn(name = "testing_session_id")
    @ManyToOne(cascade = CascadeType.MERGE, targetEntity = TestingSession.class)
    private TestingSession testingSession;

    /**
     * who created the questionnaire.
     */
    @XmlAttribute(name = "username", required = true)
    @Column(name = "username")
    private String username;

    @XmlAttribute(name = "usernameCasKey")
    @Column(name = "username_cas_key", length = KEY_LENGTH)
    private String usernameCasKey;
    /**
     * An attribute containing marshalled element node
     */
    @XmlTransient
    @Transient
    private org.w3c.dom.Node xmlNodePresentation;

    public ATNAQuestionnaireType() {
        super();
        status = Status.INPROGRESS;
        systemType = SystemType.UNKNOWN;
    }

    @PreUpdate
    @PrePersist
    public void onUpdate() {
        if (Identity.instance().isLoggedIn()) {
            setLastModifier(Identity.instance().getCredentials().getUsername(),
                    UserAttributes.instance().getCasKeyword());
        }
        setLastModifiedDate(new Date());
    }

    /**
     * Return networkCommunications.
     *
     * @return networkCommunication : One entry per configuration from TM
     */
    public List<NetworkCommunication> getNetworkCommunications() {
        if (networkCommunications == null) {
            networkCommunications = new ArrayList<NetworkCommunication>();
        }
        return networkCommunications;
    }

    /**
     * Add a networkCommunication to the networkCommunication collection. This perform a bidirectionnnal association.
     *
     * @param networkCommunicationElt Element to add.
     */
    public void addNetworkCommunication(NetworkCommunication networkCommunicationElt) {
        networkCommunicationElt.setAtnaQuestionnaire(this);
        this.getNetworkCommunications().add(networkCommunicationElt);
    }

    /**
     * Add all given networkCommunications to the networkCommunication collection. This perform bidirectionnnal associations.
     *
     * @param networkCommunicationList Elements to add.
     */
    public void addAllNetworkCommunication(List<NetworkCommunication> networkCommunicationList) {
        if (networkCommunicationList != null) {
            for (NetworkCommunication networkCommunication : networkCommunicationList) {
                addNetworkCommunication(networkCommunication);
            }
        }
    }

    /**
     * Remove a networkCommunication from the networkCommunication collection.
     *
     * @param networkCommunicationElt Element to remove
     */
    public void removeNetworkCommunication(NetworkCommunication networkCommunicationElt) {
        getNetworkCommunications().remove(networkCommunicationElt);
    }

    /**
     * Remove all the given networkCommunications from the networkCommunication collection.
     *
     * @param networkCommunicationList Elements to remove
     */
    public void removeAllNetworkCommunication(List<NetworkCommunication> networkCommunicationList) {
        if (networkCommunicationList != null) {
            for (NetworkCommunication networkCommunication : networkCommunicationList) {
                removeNetworkCommunication(networkCommunication);
            }
        }
    }

    /**
     * Return auditedEvent.
     *
     * @return auditedEvent : list the events which must be audited and give the user the possibility to attach the link to the EVSClient report of
     * audit trail message validationlist the events which
     * must be audited and give the user the possibility to attach the link to the EVSClient report of audit trail message validation
     */
    public List<AuditedEvent> getAuditedEvent() {
        if (auditedEvent == null) {
            auditedEvent = new ArrayList<AuditedEvent>();
        }
        return auditedEvent;
    }

    /**
     * Add an auditedEvent to the auditedEvent collection.  This perform a bidirectionnnal association.
     *
     * @param auditedEventElt Element to add.
     */
    public void addAuditedEvent(AuditedEvent auditedEventElt) {
        auditedEventElt.setAtnaQuestionnaire(this);
        this.getAuditedEvent().add(auditedEventElt);
    }

    /**
     * Add all given auditedEvents to the auditedEvent collection.  This perform bidirectionnnal associations.
     *
     * @param auditedEventList Elements to add.
     */
    public void addAllAuditedEvent(List<AuditedEvent> auditedEventList) {
        if (auditedEventList != null) {
            for (AuditedEvent auditedEvent : auditedEventList) {
                addAuditedEvent(auditedEvent);
            }
        }
    }

    /**
     * Remove a auditedEvent to the auditedEvent collection.
     *
     * @param auditedEventElt Element to remove
     */
    public void removeAuditedEvent(AuditedEvent auditedEventElt) {
        this.getAuditedEvent().remove(auditedEventElt);
    }

    /**
     * Remove all given auditedEvents from the auditedEvent collection.
     *
     * @param auditedEventList Elements to remove
     */
    public void removeAllAuditedEvent(List<AuditedEvent> auditedEventList) {
        if (auditedEventList != null) {
            for (AuditedEvent auditedEvent : auditedEventList) {
                removeAuditedEvent(auditedEvent);
            }
        }
    }

    /**
     * Return localUserAuthenticationProcess.
     *
     * @return localUserAuthenticationProcess : In the former questionnaire, user was asked to describe the authentication process of local usersIn
     * the former questionnaire, user was asked to describe
     * the authentication process of local users
     */
    public String getLocalUserAuthenticationProcess() {
        return localUserAuthenticationProcess;
    }

    /**
     * Set a value to attribute localUserAuthenticationProcess.
     *
     * @param localUserAuthenticationProcess : In the former questionnaire, user was asked to describe the authentication process of local usersIn
     *                                       the former questionnaire, user was asked to describe the authentication process
     *                                       of local users.
     */
    public void setLocalUserAuthenticationProcess(String localUserAuthenticationProcess) {
        this.localUserAuthenticationProcess = localUserAuthenticationProcess;
    }

    /**
     * Return tLSTest.
     *
     * @return tLSTest : One entry per inbound/outbound network communication type : Will help the user to know which TLS tests to perform and the
     * monitor to check that all tests were performed and
     * OKOne entry per inbound/outbound network communication type : Will help the user to know which TLS tests to perform and the monitor to check
     * that all tests were performed and OK
     */
    public List<TLSTest> getTLSTest() {
        if (tLSTest == null) {
            this.tLSTest = new ArrayList<TLSTest>();
        }
        return this.tLSTest;
    }

    /**
     * Add a tLSTest to the tLSTest collection. This perform a bidirectionnnal association.
     *
     * @param tLSTestElt Element to add.
     */
    public void addTLSTest(TLSTest tLSTestElt) {
        tLSTestElt.setAtnaQuestionnaire(this);
        getTLSTest().add(tLSTestElt);
    }

    /**
     * Add all given TLSTests to the TLSTest collection. This perform bidirectionnnal associations.
     *
     * @param tlsTestList Elements to add.
     */
    public void addAllTLSTest(List<TLSTest> tlsTestList) {
        if (tlsTestList != null) {
            for (TLSTest tlsTest : tlsTestList) {
                addTLSTest(tlsTest);
            }
        }
    }

    /**
     * Remove a tLSTest to the tLSTest collection.
     *
     * @param tLSTestElt Element to remove
     */
    public void removeTLSTest(TLSTest tLSTestElt) {
        this.getTLSTest().remove(tLSTestElt);
    }

    /**
     * Remove all given TLSTest(s) from the TLSTest collection.
     *
     * @param tlsTestList Elements to remove
     */
    public void removeAllTLSTest(List<TLSTest> tlsTestList) {
        if (tlsTestList != null) {
            for (TLSTest tlsTest : tlsTestList) {
                removeTLSTest(tlsTest);
            }
        }
    }

    /**
     * Return nonNetworkMeanForAcessingPHI.
     *
     * @return nonNetworkMeanForAcessingPHI : comes from 3b in former questionnaire, needs to determine what we expect here in the new
     * questionnairecomes from 3b in former questionnaire, needs to
     * determine what we expect here in the new questionnaire
     */
    public String getNonNetworkMeanForAccessingPHI() {
        return nonNetworkMeanForAccessingPHI;
    }

    /**
     * Set a value to attribute nonNetworkMeanForAcessingPHI.
     *
     * @param nonNetworkMeanForAcessingPHI : comes from 3b in former questionnaire, needs to determine what we expect here in the new
     *                                     questionnairecomes from 3b in former questionnaire, needs to determine what we expect here
     *                                     in the new questionnaire.
     */
    public void setNonNetworkMeanForAccessingPHI(String nonNetworkMeanForAcessingPHI) {
        this.nonNetworkMeanForAccessingPHI = nonNetworkMeanForAcessingPHI;
    }

    /**
     * Return company.
     *
     * @return company : which company owns the SUTwhich company owns the SUT
     */
    public String getCompany() {
        return company;
    }

    /**
     * Set a value to attribute company.
     *
     * @param company : which company owns the SUTwhich company owns the SUT.
     */
    public void setCompany(String company) {
        this.company = company;
    }

    /**
     * Return lastModified.
     *
     * @return lastModified
     */
    public javax.xml.datatype.XMLGregorianCalendar getLastModified() {
        return lastModified;
    }

    /**
     * Set a value to attribute lastModified.
     *
     * @param lastModified .
     */
    public void setLastModified(javax.xml.datatype.XMLGregorianCalendar lastModified) {
        this.lastModified = lastModified;
    }

    /**
     * Return lastModifier.
     *
     * @return lastModifier
     */
    public String getLastModifier() {
        return lastModifier;
    }

    /**
     * Return last modifier username with cas keyword in brackets.
     *
     * @return lastModifier with lastModifierCasKey
     */
    public String getLastModifierWithKey() {
        return lastModifier + " (" + lastModifierCasKey + ")";
    }

    /**
     * Set a value to attribute lastModifier and lastModifierCasKey.
     *
     * @param lastModifier       username
     * @param lastModifierCasKey user cas keyword
     */
    public void setLastModifier(String lastModifier, String lastModifierCasKey) {
        this.lastModifier = lastModifier;
        this.lastModifierCasKey = lastModifierCasKey;
    }

    /**
     * Return lastModifierCasKey
     *
     * @return lastModifierCasKey
     */
    public String getLastModifierCasKey() {
        return lastModifierCasKey;
    }

    /**
     * Return oid.
     *
     * @return oid : unique identifier of the questionnaireunique identifier of the questionnaire
     */
    public String getOid() {
        return oid;
    }

    /**
     * Set a value to attribute oid.
     *
     * @param oid : unique identifier of the questionnaireunique identifier of the questionnaire.
     */
    public void setOid(String oid) {
        this.oid = oid;
    }

    /**
     * Return reviewer.
     *
     * @return reviewer : monitor who reviewed the questionnaire
     */
    public String getReviewer() {
        return reviewer;
    }

    /**
     * Return reviewer username with its cas keyword in brackets.
     *
     * @return reviewer with reviewerCasKey
     */
    public String getReviewerWithKey() {
        return reviewer + " (" + reviewerCasKey + ")";
    }

    /**
     * Set a value to attribute reviewer and reviewerCasKey.
     *
     * @param reviewer       username
     * @param reviewerCasKey user cas keyword
     */
    public void setReviewer(String reviewer, String reviewerCasKey) {
        this.reviewer = reviewer;
        this.reviewerCasKey = reviewerCasKey;
    }

    /**
     * Return reviewerCasKey
     *
     * @return reviewerCasKey
     */
    public String getReviewerCasKey() {
        return reviewerCasKey;
    }

    /**
     * Return status.
     *
     * @return status : status of the questionnairestatus of the questionnaire
     */
    public Status getStatus() {
        return status;
    }

    /**
     * Set a value to attribute status.
     *
     * @param status : status of the questionnairestatus of the questionnaire.
     */
    public void setStatus(Status status) {
        this.status = status;
    }

    /**
     * Return system.
     *
     * @return system : system keyword in TMsystem keyword in TM
     */
    @FilterLabel
    public String getSystem() {
        return system;
    }

    /**
     * Set a value to attribute system.
     *
     * @param system : system keyword in TMsystem keyword in TM.
     */
    public void setSystem(String system) {
        this.system = system;
    }

    /**
     * Return systemType.
     *
     * @return systemType : is the SUT secure application or secure nodeis the SUT secure application or secure node
     */
    public SystemType getSystemType() {
        return systemType;
    }

    /**
     * Set a value to attribute systemType.
     *
     * @param systemType : is the SUT secure application or secure nodeis the SUT secure application or secure node.
     */
    public void setSystemType(SystemType systemType) {
        this.systemType = systemType;
    }

    /**
     * Return testingSession.
     *
     * @return testingSession
     */
    public TestingSession getTestingSession() {
        return testingSession;
    }

    /**
     * Set a value to attribute testingSession.
     *
     * @param testingSession .
     */
    public void setTestingSession(TestingSession testingSession) {
        this.testingSession = testingSession;
    }

    /**
     * Return username.
     *
     * @return username : who created the questionnairewho created the questionnaire
     */
    public String getUsername() {
        return username;
    }

    /**
     * Return username with its cas keyword in brackets.
     *
     * @return username concatenated with usernameCasKey
     */
    public String getUsernameWithKey() {
        return username + " (" + usernameCasKey + ")";
    }

    /**
     * Set a value to attribute username.
     *
     * @param username       who created the questionnaire.
     * @param usernameCasKey cas keyword
     */
    public void setUsername(String username, String usernameCasKey) {
        this.username = username;
        this.usernameCasKey = usernameCasKey;
    }

    public String getUsernameCasKey() {
        return usernameCasKey;
    }

    public Node getXmlNodePresentation() {
        if (xmlNodePresentation == null) {
            xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "ATNAQuestionnaire", this);
        }
        return xmlNodePresentation;
    }

    public void setXmlNodePresentation(Node xmlNodePresentation) {
        this.xmlNodePresentation = xmlNodePresentation;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public List<TLSTest> gettLSTest() {
        return getTLSTest();
    }

    public void settLSTest(List<TLSTest> tLSTest) {
        this.tLSTest = tLSTest;
    }

    public Date getLastModifiedDate() {
        return (Date) lastModifiedDate.clone();
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = (Date) lastModifiedDate.clone();
    }

    public List<NetworkCommunication> getInboundNetworkCommunications() {
        List<NetworkCommunication> result = new ArrayList<NetworkCommunication>();
        for (NetworkCommunication nc : this.getNetworkCommunications()) {
            if (nc.getInOut() == InOut.IN) {
                result.add(nc);
            }
        }
        return result;
    }

    public List<NetworkCommunication> getOutboundNetworkCommunications() {
        List<NetworkCommunication> result = new ArrayList<NetworkCommunication>();
        for (NetworkCommunication nc : this.getNetworkCommunications()) {
            if (nc.getInOut() == InOut.OUT) {
                result.add(nc);
            }
        }
        return result;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((system == null) ? 0 : system.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        ATNAQuestionnaireType other = (ATNAQuestionnaireType) obj;
        if (system == null) {
            if (other.system != null) {
                return false;
            }
        } else if (!system.equals(other.system)) {
            return false;
        }
        return true;
    }

    public boolean systemIsSecureNode() {
        return SystemType.SECURENODE.equals(systemType);
    }

}